import type * as c4 from '@likec4/core';
import { type ParsedAstDeploymentView, ast } from '../../ast';
import type { WithDeploymentModel } from './DeploymentModelParser';
import type { WithExpressionV2 } from './FqnRefParser';
export type WithDeploymentView = ReturnType<typeof DeploymentViewParser>;
export declare function DeploymentViewParser<TBase extends WithExpressionV2 & WithDeploymentModel>(B: TBase): {
    new (...args: any[]): {
        parseDeploymentView(astNode: ast.DeploymentView): ParsedAstDeploymentView;
        parseDeploymentViewRule(astRule: ast.DeploymentViewRule): c4.DeploymentViewRule;
        parseDeploymentViewRulePredicate(astRule: ast.DeploymentViewRulePredicate): c4.DeploymentViewRulePredicate;
        parseDeploymentViewRuleStyle(astRule: ast.DeploymentViewRuleStyle): c4.DeploymentViewRuleStyle;
        parseFqnRef(astNode: ast.FqnRef): c4.FqnRef;
        parseFqnExpr(astNode: ast.FqnExpr): c4.FqnExpr;
        parseFqnRefExpr(astNode: ast.FqnRefExpr): c4.FqnExpr.NonWildcard;
        parseFqnExpressions(astNode: ast.FqnExpressions): c4.FqnExpr[];
        parseRelationWhereExpr(astNode: ast.RelationPredicateWhereV2): c4.RelationExpr;
        parseRelationExpr(astNode: ast.RelationExpr): c4.RelationExpr;
        isValid: import("../../validation").IsValidFn;
        readonly services: import("../..").LikeC4Services;
        readonly doc: import("../../ast").ParsedLikeC4LangiumDocument;
        resolveFqn(node: ast.FqnReferenceable): c4.Fqn;
        getAstNodePath(node: c4): any;
        getMetadata(metadataAstNode: ast.MetadataProperty | undefined): {
            [key: string]: string;
        } | undefined;
        convertTags<E extends {
            tags?: ast.Tags;
        }>(withTags?: E | undefined): any;
        parseTags<E extends {
            tags?: ast.Tags;
        }>(withTags?: E): c4.NonEmptyArray<c4.Tag> | null;
        convertLinks(source?: ast.LinkProperty["$container"]): import("../../ast").ParsedLink[] | undefined;
        parseLinks(source?: ast.LinkProperty["$container"]): import("../../ast").ParsedLink[] | undefined;
        parseDeployment(): void;
        parseDeploymentNode(astNode: ast.DeploymentNode): import("../../ast").ParsedAstDeployment.Node;
        parseDeployedInstance(astNode: ast.DeployedInstance): import("../../ast").ParsedAstDeployment.Instance;
        parseDeploymentRelation(astNode: ast.DeploymentRelation): import("../../ast").ParsedAstDeploymentRelation;
    };
} & TBase;
